.TH BTGNCLI 1 "28 May 2007"
.SH NAME
btgncli \- bittorrent client, part of the btg project.
.SH SYNOPSIS
.B "btgncli" 
[-o 
.I "<filename>"
]
[--nostart]
[-l]
[--noutput]
[--command 
.I "<command>"
]
[-A]
[-a]
[-s 
.I "<session ID>"
]
[--config 
.I "<filename>"
]
[--dht]
[--no-dht]
[--encryption]
[--no-encryption]
[-v] 
[-h]

.SH DESCRIPTION
.B "btgncli" 
is a ncurses bittorrent client.

If started without any arguments, it will attempt to connect to the
daemon (btgdaemon) and start a new session.

After the client connects to the daemon and initializes, it will
present a list of torrents (if the client attached to a session with
torrents). Press the help key (default /h/) to get help.

.SH OPTIONS

.TP
.BI "-o" 
.I "<filename>"
\- Name of a torrent file to open after initializing the client.

.TP
.BI "--nostart" 
\- Do not start torrents after opening them. The default is to start a torrent after it was opened.

.TP
.BI "-l" 
\- List running sessions.

.TP
.BI "-A" 
\- Attach to the first available session.

.TP
.BI "-a" 
\- Show a list of sessions and let the user choose which session to attach to.

.TP
.BI "-s" 
.I "<session ID>"
\- Attach to a session described by the session ID.

.TP
.BI "--config" 
.I "<filename>"
\- Name of a client configuration file to use.

.TP
.BI "--dht"
\- Enable DHT.

.TP
.BI "--no-dht"
\- Disable DHT.

.TP
.BI "--encryption"
\- Enable encryption.

.TP
.BI "--no-encryption"
\- Disable encryption.

.TP
.BI "-v"
\- Be verbose.

.TP
.BI "-h|--help"
\- Print a short help.

.SH FILES
See btg_config(1).

.SH CONFIGURATION
.TP 
See btg_config(1).

One can setup the keys and colors to be used by adding a "btgncli" section to the
client config file. See below.

.SH COLORS
.TP
Colors can be setup using the following keys.

.TP
COLOR_NORMAL
.TP
COLOR_BORDER
.TP
COLOR_FILE
.TP
COLOR_DIRECTORY
.TP
COLOR_MARK
.TP
COLOR_WARNING
.TP
COLOR_ERROR

.TP
A color can be setup with the following string: "R,G,B:R,G,B", where
the first RGB value is the foreground color and the second RGB value
is the background color. Notice that while the terminal used may
support using colors, it is not certain that is supports changing the
defined colors. If that is the case, btgncli will use the default
colors and ignore any user defined colors.

.SH KEYBOARD
.TP
Use the following configuration keys:

.TP
KEY_HELP
.TP
KEY_DETACH
.TP
KEY_QUIT
.TP
KEY_LOAD
.TP
KEY_MENU
.TP
KEY_GLIMIT
.TP
KEY_DOWN
.TP
KEY_UP
.TP
KEY_LIST_START
.TP
KEY_LIST_END
.TP
KEY_SELECT
.TP
KEY_MARK
.TP
KEY_MARK_ALL
.TP
KEY_NEXT
.TP
KEY_PREV

.TP
For example, to set the help key to "h", one has to use the ASCII
value 104.

.SH EXAMPLE CONFIG
An example "btgncli" section is below.

.nf
[btgncli]
;
; Keys:
;

; h
KEY_HELP=104
; D
KEY_DETACH=68
; q
KEY_QUIT=113
; l
KEY_LOAD=108
; m
KEY_MENU=109
; g
KEY_GLIMIT=103
; x
KEY_DOWN=120
; w
KEY_UP=119
; a
KEY_LIST_START=97
; d
KEY_LIST_END=100
; return
KEY_SELECT=10
; s
KEY_MARK=115
; p
KEY_MARK_ALL=111
; b
KEY_NEXT=98
; v
KEY_PREV=118

;
; Colors;
;

COLOR_NORMAL=192,192,192:0,0,0
COLOR_BORDER=142,229,238:0,0,0

.fi 

.SH AUTHOR
Written by Michael Wojciechowski.

.SH "SEE ALSO"
btg(5), btg_config(5), btgcli(1), btgui(1), btgdaemon(1), btgd(1)

.SH BUGS
No known bugs.
