<?php
/*
 * btg Copyright (C) 2005 Michael Wojciechowski.
 * PHP client written by Johan Ström.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
 * $Id: context_li_status_rsp.php,v 1.1.4.17 2007/09/17 15:34:51 wojci Exp $
 */
if(!defined("BTG_BCORE_PATH"))
	define("BTG_BCORE_PATH", "bcore");

require_once(BTG_BCORE_PATH."/command/context.php");
require_once(BTG_BCORE_PATH."/command/limit_base.php");

class contextLimitStatusResponseCommand extends contextCommand
{
	private $limitUpld;
	private $limitDwnld;
	private $seedLimit;
	private $seedTimeout;

	public function contextLimitStatusResponseCommand($context_id=contextCommand::UNDEFINED_CONTEXT, $limitBytesUpld = limitBase::LIMIT_DISABLED, $limitBytesDwnld = limitBase::LIMIT_DISABLED, $seedLimit = limitBase::LIMIT_DISABLED, $seedTimeout = limitBase::LIMIT_DISABLED)
	{
		parent::__construct(Command::CN_CLIMITSTATUSRSP, $context_id, false);
		$this->limitUpld = $limitBytesUpld;
		$this->limitDwnld = $limitBytesDwnld;
		$this->seedLimit = $seedLimit;
		$this->seedTimeout = $seedTimeout;
	}

	public function getUploadLimit()
	{
		return $this->limitUpld;
	}

	public function getDownloadLimit()
	{
		return $this->limitDwnld;
	}

	public function getSeedLimit()
	{
		return $this->seedLimit;
	}

	public function getSeedTimeout()
	{
		return $this->seedTimeout;
	}

	public function serialize(&$a = array())
	{
		$a = parent::serialize();
		$this->intToBytes($a, $this->limitUpld);
		$this->intToBytes($a, $this->limitDwnld);
		$this->intToBytes($a, $this->seedLimit);
		$this->longToBytes($a, $this->seedTimeout);
		return $a;
	}

	public function deserialize(&$data)
	{
		parent::deserialize($data);
		$this->bytesToInt($this->limitUpld, $data);
		$this->bytesToInt($this->limitDwnld, $data);
		$this->bytesToInt($this->seedLimit, $data);
		$this->bytesToLong($this->seedTimeout, $data);
	}
}

?>
